#compiler
FC=@FC@
CC=@CC@
LD=@LD@
CFLAGS=@CFLAGS@
FCFLAGS=@FCFLAGS@
LDFLAGS=@LDFLAGS@
# optimization flags
OPTFLAGS=@OPTFLAGS@
PPFLAGS = @PPFLAGS@
PPCMD   = @PPCMD@
IPATH =  @IPATH@
LIBS   = @LIBS@
LPATH =  @LPATH@
DISF90=  @DISF90@
DISOBJ=  @DISOBJ@
FCLIBS = @FCLIBS@
SHAREDOBJ=@SHAREDOBJ@
MAKECMD=@MAKECMD@

AR	      = @AR@
RANLIB    = @RANLIB@


ALL01OBJ =  all_type.o ipt_decl.o random.o common_mod.o #nxtval.o
ALL01F90 = all_type.$(EXTF90) piktools.$(EXTF90) random.$(EXTF90) tools.$(EXTF90) #nxtval.$(EXTF90)

PIKMPIOBJ = ff_slave.o mpi_fitness.o pikaia_master.o 

F77SRC = pikaia.f fmedian.f
F90SRC = all_type.f90 ipt_decl.f90 tools.f90 common_mod.f90  median.f90 remove_spike.f90 norm_ff.f90 interpolate.f90 get_pb_splitting.f90 read_atminput.f90 get_pb_strength.f90 file_open.f90 read_atom.f90 read_ipt.f90 def_line.f90 def_pb.f90 cuanten.f90 create_nc.f90  uobyqa.f90 check_scaling.f90 get_pikaia_idx.f90 call_pikaia.f90 compute_profile.f90 voigt.f90  voigt_init.f90 voigt_taylor.f90 get_simple_cont.f90 get_profile.f90 get_profidx.f90 convolve.f90 fftpack.f90 readsto.f90 fill_localstray.f90 readfits_hinode.f90 read_ccx.f90 read_hinode.f90 read_imax.f90 read_fits4d.f90 get_lsprof.f90 read_tip.f90 read_conv.f90 read_prefilter.f90 add_noise.f90 smooth.f90 get_wgt.f90 run_inversion.f90 write_atm.f90 plot_profile.f90 helix.f90

#modules whith module nam equal to filename must be treated separately:
MODSRC= all_type.f90 ipt_decl.o common_mod.f90 random.f90 ftime.f90 tools.f90 fitsout.f90 localstray_com.f90 localstraycomp_com.f90 nxtval.f90 piktools.f90 cons_param.f90 hanle_module.f90 voigt_data.f90 read_atminput.f90

CLUDSRC=nrutil.c f90_lud.c lubksb.c ludcmp.c ludtest.c

HELIBO=nxtval.o ftime.o
HELIBA=libnxt.a libftime.a

F77OBJ=${F77SRC:.f=.o}
F90OBJ=${F90SRC:.f90=.o}
MODOBJ=${MODSRC:.f90=.o}
CLUDOBJ=${CLUDSRC:.c=.o}
SRC=$(DISF90) $(CLUDSRC) $(MODSRC) $(F77SRC) $(F90SRC)
OBJ=$(DISOBJ) $(CLUDOBJ) $(MODOBJ) $(F77OBJ) $(F90OBJ)
MOD=${MODSRC:.f90=.mod}

.SUFFIXES: .mod .o .a .c .f .f90

dislin.o: $(DISF90)
	$(FC) -c $(PPCMD) $(PPFLAGS) $(OPTFLAGS) $(IPATH) $(FCFLAGS) $(DISF90)

.f90.o:
	$(FC) -c $(PPCMD) $(PPFLAGS) $(OPTFLAGS) $(IPATH) $(FCFLAGS) $< 

.f90.mod:
	$(FC) -c $(PPCMD) $(PPFLAGS) $(OPTFLAGS) $(IPATH) $(FCFLAGS) $< 

.f.o:
	$(FC) -c $(PPCMD) $(PPFLAGS) $(OPTFLAGS) $(IPATH) $(FCFLAGS) $< 

.c.o:
	$(CC) -c $(IPATH) $(CFLAGS) $< 
#	$(CC) -c $(CCFLAGS) $(IPATH) $< 

liblud.a: $(CLUDOBJ)
	$(AR) rv liblud.a $(CLUDOBJ)

$(HELIBA): $(HELIBO)
	$(AR) srcv $(@) $<

mpitest.o: mpitest.f90
	$(FC) -c $(PPCMD) $(PPFLAGS) $(OPTFLAGS) $(IPATH) $(FCFLAGS) mpitest.f90

compute_profile.so: $(OBJ)
	$(FC) $(IPATH) $(LPATH) $(FCFLAGS) $(LIBS) -o compute_profile.so common_mod.o interpolate.o fftpack.o norm_ff.o  convolve.o get_pb_splitting.o get_pb_strength.o voigt.o voigt_data.o voigt_init.o voigt_taylor.o ftime.o hanle_module.o compute_profile.o


call_pikaia.so: $(OBJ)
	$(FC) $(IPATH) $(LPATH) $(FCFLAGS) $(LIBS) -o call_pikaia.so piktools.o get_pikaia_idx.o random.o read_conv.o read_prefilter.o fftpack.o convolve.o common_mod.o norm_ff.o uobyqa.o call_pikaia.o pikaia.o voigt.o voigt_data.o voigt_init.o voigt_taylor.o get_pb_splitting.o get_pb_strength.o ipt_decl.o fill_localstray.o tools.o localstray_com.o localstraycomp_com.o interpolate.o ftime.o hanle_module.o compute_profile.o

all: $(MAKECMD)

helix:
	$(MAKE) $(MOD) $(MAKEFILE)
	$(MAKE) $(OBJ) $(MAKEFILE)

idlso: $(SHAREDOBJ) #$(HELIBA) liblud.a

clean:
	rm -f *.o *.mod *.a helix

distclean: clean
	rm -f *.a
	rm -f Makefile

#
